ADN Open CIS
Сообщество программистов Autodesk в СНГ

09/08/2013

Как FACETRES/VIEWRES соотносятся с AcGiCommonDraw::deviation() в ObjectARX

Вопрос:

Вы можете подробно объяснить как FACETRES и VIEWRES соотносятся с методом deviation() в классе AcGiCommonDraw?

Ответ:

Отклонение - (2D и 3D) это значение, которое управляет тонкостью тесселяции. Если значения стремится к нулю, тесселяция увеличивается...

Опубликовано 09.08.2013     Читать далее >>>
08/08/2013

Как вычислить длину примитива в ObjectARX/.NET

Вы можете использовать методы getStartParam() и getEndParam() для получения начального и конечного параметров кривой - унаследованного от AcDbCurve примитива. Затем используя метод getDistAtParam() можно получить длину кривой. Смотрите ниже код для получения длины:

Опубликовано 08.08.2013     Читать далее >>>
07/08/2013

Делаем быстрыми worldDraw и viewportDraw пользовательского объекта

Вопрос:

Мой пользовательский примитив довольно сложный, и всякий раз, когда мои пользователи вызывают команды ПОВЕРНУТЬ (ROTATE) или ПЕРЕНЕСТИ (MOVE) или что-то, что требует постоянного обновления графики, эти операции становятся очень прерывистыми и медленными. Как я могу исправить эту ситуацию?

Опубликовано 07.08.2013     Читать далее >>>
05/08/2013

Создание поверхности сопряжения ассоциированной с краями.

Это пример кода, создающего поверхность сопряжения, которая ассоциативно связана с краями двух других поверхностей. Ассоциативность подразумевает, что при изменении любой из этих поверхностей средствами AutoCAD, поверхность сопряжения будет автоматически изменена.

В этом коде создаются две выдавленных поверхности. Информация о краях этих поверхностей используется для создания профиля по сечениям. Профиль по сечениям используется для создания поверхности сопряжения.

Опубликовано 05.08.2013     Читать далее >>>
02/08/2013

Как преобразовать AcGeCircArc3d в AcDbArc и наоборот?

Следующий код показывает как это сделать:

Опубликовано 02.08.2013     Читать далее >>>
31/07/2013

Как поместить текст в нужное место, если текст имеет выравнивание?

Мы хотим поместить текст в определенное место с выравниванием СЦ (Середина-Центр). Но текст не помещается в нужно место несмотря на то, что выравнивание задано правильно.

Если вы хотите установить местоположение текста путем изменения его точка выравнивания, пожалуйста, воспользуйтесь кодом:

oTextEnt.AlignmentPoint = newPoint

Опубликовано 31.07.2013     Читать далее >>>
29/07/2013

Как получить свойство документа?

Если вы хотите получить доступ к свойству документа, как это делает команда СВОЙСТВАРИС (DWGPROPS) вам нужно будет воспользоваться функцией acdbGetSummaryInfo. Это глобальная функция, которая получает информацию файла.

Опубликовано 29.07.2013     Читать далее >>>
27/07/2013

Как получить заштрихованный примитив из примитива штриховки (HATCH)?

Когда примитив заштрихован ассоциативной штриховкой (AcDbHatch) – штриховка ассоциирована с заштрихованным примитивом. Как можно найти эту штриховку?

Штриховка реагирует на изменение примитива путём уведомления. В действительности штриховка имеет постоянный реактор на заштрихованный примитив. Этим можно воспользоваться для получения штриховки. Следующий код демонстрирует это:

Опубликовано 27.07.2013     Читать далее >>>
25/07/2013

Как получить координаты курсора мыши в ПСК?

Следующий код (фильтр сообщений окна) получает и печатает координаты курсора мыши в ПСК. Координаты те же, что показывает AutoCAD в свой строке состояния.

Опубликовано 25.07.2013     Читать далее >>>
23/07/2013

Как получить доступ к флагу 'Задание пути' в диалоге ССЫЛКА?

Не существует ни системной переменной, ни пользовательской настройки, которая позволила бы получить доступ к этому флагу, кроме того, что обеспечивается с помощью команды ССЫЛКА (XREF). Тем не менее, при помощи кода можно установить путь внешней ссылки напрямую.

Опубликовано 23.07.2013     Читать далее >>>
22/07/2013

В каком случае набор выбора, возвращаемый acedGetCurrentSelectionSet() действителен в ObjectARX?

Вопрос:

Я не могу понять в каком случае acedGetCurrentSelectionSet() должен вернуть мне действительный набор выбора. Можете объяснить мне?

Кроме того, как мне очистить набор предварительного выбора (PICKFIRST)?

Ответ:

Функция acedGetCurrentSelectionSet() заполняет набор выбора значениями ObjectID всех примитивов из текущего набора выбора AutoCAD. «Текущий набор выбора» может быть одним из следующих:

Опубликовано 22.07.2013     Читать далее >>>
20/07/2013

Как показать правильно числовое значение в Панели Свойств (OPM)?

Вопрос:

Я создал COM-обертку для собственного примитива. Похоже, что любые плавающие значения, которые я добавляю в COM-обертку автоматически показываются так, как установлено в диалоге «Единицы чертежа». Например, значение 14.500 автоматически отображается в Панели Свойств AutoCAD как 1'-2½".

Есть ли способ переопределить это поведение Панели свойств, чтобы плавающее число не меняло свой вид и показывалось «как есть»?

Ответ:

По умолчанию Панель Свойств интерпретирует плавающие числа как значение расстояния.

Опубликовано 20.07.2013     Читать далее >>>
19/07/2013

Как восстановить потерянные границы штриховки?

Вопрос:

Как можно восстановить границы штриховки, если они были потеряны по каким-то причинам?

Ответ:

В AutoCAD’е нет отдельной команды, которая бы восстанавливала контур штриховки, но это можно сделать средствами ObjectARX API.

Опубликовано 19.07.2013     Читать далее >>>
19/07/2013

В какой системе координат возвращает точку GetClosestPointTo() для вставки блока при помощи ObjectARX

Вопрос:

Почему координаты ближайшей точки (с использованием GetClosestPointTo()) полученной для вставки блока не соответствуют ни МСК (WCS), ни ПСК (UCS)?

Ответ:

Точки получаются относительно системы координат AcDbBlockTableRecord владельца. Если вы хотите конвертировать из системы координат AcDbBlockTableRecord, в которой находится AcDbBlockReference, вам нужно преобразовать их при помощи AcDbBlockReference::blockTransform().

Опубликовано 19.07.2013     Читать далее >>>
18/07/2013

Как определить что свойства примитива изменены при помощи Панели Свойств?

Вопрос:

Как я могу узнать, что свойства примитива изменены через Панель свойств (OPM)?

Ответ:

Панель свойств при изменении объекта запускает уведомления о событиях начала и конца модификации, используя строку "OPM_CHGPROP"

Опубликовано 18.07.2013     Читать далее >>>
11/07/2013

Как использовать метод AcDbRegion::getAreaProp()

Первые три параметра метода описываются как:

  • origin — Возвращает начальную точку области
  • xAxis — Возвращает ось X области
  • yAxis — Возвращает ось Y области

Но учитывая объявления этих параметров как const :

Опубликовано 11.07.2013     Читать далее >>>
09/07/2013

Как использовать класс AcadAppInfo для чтения и записи информации из реестра

Вопрос:
Как можно использовать класс AcadAppInfo для чтения и записи информации из (в) реестр?

Ответ:
Следующий код подразумевает, что вы загрузили пример POLYSAMP в AutoCAD. (Вы можете найти этот пример в каталоге ObjectARX SDK\Samples\entity\). Измените имя приложения в аргументе функции setAppName() чтобы получить собственную информацию вашего приложения из реестра.

Опубликовано 09.07.2013     Читать далее >>>
05/07/2013

Как использовать длинные транзакции для эмуляции команды -ССЫЛРЕД

Команды -ССЫЛРЕД (-REFEDIT) и ССЫЛРЕД (REFEDIT) обеспечивают возможность контекстного редактирования блока (по месту). Они позволяют переключатся между вложенными ссылками блока. Тогда AutoCAD принимает подсвеченную вставку блока для редактирования по месту. Приложение посылает команду -ССЫЛРЕД для переключения в режим редактирования для удобства пользователя.

Опубликовано 05.07.2013     Читать далее >>>
03/07/2013

Как заставить команду УВЕЛИЧИТЬ работать с пользовательским примитивом

Команда УВЕЛИЧИТЬ (LENGTHEN) может работать только со следующими классами или пользовательскими объектами, унаследованными от этих классов:

Опубликовано 03.07.2013     Читать далее >>>
01/07/2013

Visual Studio 2008 для ObjectARX 2010/11/12

Правильная версия для работы с ObjectARX SDK 2010, 2011, 2012 – это VisualStudio 2008 с ServicePack 1.

Опубликовано 01.07.2013     Читать далее >>>